/*
	Sogna VIPER-BTR,CTR
	for LSI-C(86)
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

unsigned long decodeSFX( unsigned char *inbuf, unsigned long size, unsigned char *outbuf )
{
	unsigned char	ad;
	unsigned char	bd;
	unsigned char	cd;
	unsigned char	dd;

	unsigned int	adr = 0;
	unsigned int	ct;
	unsigned int	adb = 0;	/* outbuf ofs */
	unsigned int	adl = 0;	/* dic ofs */

	unsigned int	adsl = 0;	/* inbuf ofs */
	int				tpb;
	int				tpc;
	unsigned char	*dra;
	unsigned long	outcount = 0L;

	dra = ( unsigned char *)calloc( 1, 4096 );

	while( adsl < size )
	{
		for( tpb = 1; tpb <= 8; tpb++ )
		{
			ad = inbuf[adsl];
			bd = inbuf[adsl+1];

			dd = ad >> ( 8 - tpb );
			dd = dd & 0x01;

			if( dd == 0x01 )
			{
				ad =  inbuf[adsl];
				bd =  inbuf[adsl+1];
				cd =  inbuf[adsl+2];

				ad = ( ad << tpb ) + ( bd >> ( 8 - tpb ));
				bd = ( bd << tpb ) + ( cd >> ( 8 - tpb ));

				ct = ( ad & 0xF0 ) >> 4 ;
				adr = adl - (( ad & 0x0F ) * 256 + bd ) & 0x0FFF;

				for( tpc = 0 ; tpc <= ct ; tpc++ )
				{
					adl &= 0x0FFF;
					adr &= 0x0FFF;
					dra[adl] = dra[adr];
					outbuf[adb] = dra[adr];
					outcount++;
					adl++;
					adr++;
					adb++;
				}
				adsl += 2;
			} else {
				ad = ( ad << tpb ) + ( bd >> ( 8 - tpb ));
				adl &= 0x0FFF;
				dra[adl] = ad;
				outbuf[adb] = ad;
				outcount++;
				adl++;
				adsl++;
				adb++ ;
			}
		}
		adsl++;
	}

	free( dra );
	return outcount;
}

void main( int argc, char **argv )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*inbuf;
	unsigned char	*outbuf;
	unsigned long	filesize_original = 0L;
	unsigned long	filesize_compress = 0L;
	char			out_filename[256];
	char			format[2];

	printf( "Sogna MUSIC Decompress tool 070614 (c)Fac.KUROHANE\n" );

	if( argc == 1 )
	{
		printf( "usage: BTR2EXT <filename> <dest_dir>\n" );
		return;
	}

	in = fopen( argv[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", argv[1] );
		return;
	}

	/* filesize */
	fseek( in, 0, SEEK_END );
	filesize_compress = ftell( in );
	fseek( in, 0, SEEK_SET );

	printf( "filename: %s\n", argv[1] );

	/* read */
	inbuf = ( unsigned char * )calloc( 1, filesize_compress );
	fread( inbuf, filesize_compress, 1, in );
	fclose( in );

	memcpy( format, inbuf, 2 );

	if( memcmp( &inbuf[1], "MX", 2 ))
	{
		printf( "error: not Sogna Music format.\n" );
		free( inbuf );
		return;
	}

	printf( "filesize_compress: %lu bytes\n", filesize_compress );

	outbuf = ( unsigned char * )calloc( 1, 20000 );
	filesize_original = decodeSFX( &inbuf[3], filesize_compress - 3, outbuf );

	printf( "filesize_original: %lu bytes\n", filesize_original );

	free( inbuf );

	if( argc == 3 )
	{
		sprintf( out_filename, "%s%s",
			argv[2],
			argv[1]
		);
	} else sprintf( out_filename, "%s", argv[1] );

	out_filename[strlen( out_filename ) -  3] = format[0];
	out_filename[strlen( out_filename ) -  2] = format[1];

	out = fopen( out_filename, "wb+" );
	if( out == NULL )
	{
		printf( "error: can't write %s.\n", out_filename );
		return;
	}
	fwrite( outbuf, filesize_original, 1, out );
	fclose( out );

	free( outbuf );

	printf( "complete.\n" );

	return;
}
